#!/usr/bin/perl -w
use English;
use strict;
use Tk;
use IO;

my $main_win;
my $bal;
my $debits = '3.40';
my $credits = '2.85';
my $diff = '1.13';
my %cbb;

#------------------------------------------------------------------------------
# Procedures for balancing
#------------------------------------------------------------------------------

sub balance {
  # global debits credits diff

  $debits = 0.00;
  $credits = 0.00;
  $diff = balanceCalcDiff();
  
  # create or bring forward window
  cbbWindow_bal();
  
  # refresh the list
  balanceRefresh();
}


# Stubs...
sub balanceRefresh {}

# If you're really attached to using .bal.frame.head1 etc to access
# the heirarchy, then you could switch things like $head1 to
# $bal_frame_head1 or use a hash like $wid{'.bal.frame.head1'} = ...
# It depends on whether or not these are needed globally

# create window
sub cbbWindow_bal {
  # global $cbb $debits $credits $diff
  
  # assume $bal is a global too for now.
  if(Exists($bal) == 1) {
    $bal->withdraw();
    $bal->deiconify();
    return;
  }
    
  $bal = $main_win->toplevel();
  
  #$bal->optionAdd('*font' => $cbb{'dialog_font'});
  
  $bal->title("Balance ...");
  $bal->iconname("Balance ...");

  my $frame = $bal->Frame(-borderwidth => 2, -relief => 'raised');
  my $head1 = $frame->Frame(-relief => 'raised');
  my $head2 = $frame->Frame(-relief => 'raised');
  my $head3 = $frame->Frame(-relief => 'raised');
  my $f     = $frame->Frame(-relief => 'raised');
  my $bar   = $frame->Frame(-relief => 'sunken');
  
  my $h1_label = $head1->Label(-text => 'Statement Starting Balance = ');
  my $h1_entry = $head1->Entry(-textvariable => \$cbb{'state_start'},
                               -relief => 'sunken',
                               -width => 17
                               #,
                               #-font => $cbb{default_font}
                               );
  my $h2_label = $head2->Label(-text => 'Statement Ending Balance = ');
  my $h2_entry = $head2->Entry(-textvariable => \$cbb{'state_end'},
                               -relief => 'sunken',
                               -width => 17
                               #,
                               #-font => $cbb{'default_font'}
                               );
  my $h3_label = 
    $head3->Label(-text => 
                  "Debits = $debits  Credits = $credits  Difference = $diff");

  my $f_scroll;
  my $f_list = $f->Listbox(-width => 47, -height => 15, -relief => 'sunken',
                           -exportselection => 0, -takefocus => 0,
                           -yscrollcommand => [ $f_scroll => 'set' ]
                           #,
                           #-font => $cbb{'fixed_font'}
                           );

  $bal->bind('<KeyPress-Down>', sub { 
    $f_list->yview('scroll' => 1, 'units'); });
  $bal->bind('<Control-KeyPress-n>', sub { 
    $f_list->yview('scroll' => 1, 'units'); });
  $bal->bind('<KeyPress-Up>', sub { 
    $f_list->yview('scroll' => -1, 'units'); });
  $bal->bind('<Control-KeyPress-p>', sub { 
    $f_list->yview('scroll' => -1, 'units'); });
  $bal->bind('<KeyPress-Next>', sub { 
    $f_list->yview('scroll' => 1, 'units'); });
  $bal->bind('<Control-KeyPress-v>', sub { 
    $f_list->yview('scroll' => 1, 'units'); });
  $bal->bind('<KeyPress-Prior>', sub { 
    $f_list->yview('scroll' => -1, 'units'); });
  $bal->bind('<Alt-KeyPress-v>', sub { 
    $f_list->yview('scroll' => -1, 'units'); });

  $f_scroll = $f->Scrollbar(-takefocus => 0, -relief => 'flat',
                            -command => [ $f_list => 'yview' ]);
	
  my $bar_refresh = $bar->Button(-text => 'Refresh',
                                 #-font => $cbb{'button_font'},
                                 -takefocus => 0,
                                 -command => \&balanceRefresh);
  
  my $bar_update = $bar->Button(-text => 'Update',
                                #-font => $cbb{'button_font'},
                                -takefocus => 0,
                                -command => sub {
                                  balanceUpdateSelected($f_list);
                                  clear_entry_area();
                                  $bal->destroy();
                                });

  my $bar_dismiss = $bar->Button(-text => "Dismiss", 
                                 #-font => $cbb{'button_font'},
                                 -takefocus => 0,
                                 -command => sub {
                                   clear_entry_area();
                                   $bal->destroy();
                                 });

  $frame->pack(-side => 'top', -fill => 'both', -expand => 1);
  $head1->pack(-side => 'top', -fill => 'x');
  $head2->pack(-side => 'top', -fill => 'x');
  $head3->pack(-side => 'top', -fill => 'x');
  $bar->pack(-side => 'bottom', -fill => 'x');
  $f->pack(-side => 'top', -fill => 'both', -expand => 1);

  $h1_label->pack(-side => 'left', -anchor => 'w');
  $h1_entry->pack(-side => 'left', -anchor => 'w');
  $h2_label->pack(-side => 'left', -anchor => 'w');
  $h2_entry->pack(-side => 'left', -anchor => 'w');
  $h3_label->pack(-side => 'top', -anchor => 'w');

  $f_scroll->pack(-side => 'right', -fill => 'y');
  $f_list->pack(-side => 'left', -fill => 'both', -expand => 1);
  $bar_refresh->pack(-side => 'left', -expand => 1, -fill => 'x',
                     -padx => 8, -pady => 4);
  $bar_update->pack(-side => 'left', -expand => 1, -fill => 'x',
                     -padx => 8, -pady => 4);
  $bar_dismiss->pack(-side => 'left', -expand => 1, -fill => 'x',
                     -padx => 8, -pady => 4);

  $h1_entry->bind('<FocusOut>', sub {
    $diff = balanceCalcDiff();
    $h3_label->configure( -text => "Debits = $debits  " .
                            "Credits = $credits  Difference = $diff");
  });
  
  $h2_entry->bind('<FocusOut>', sub {
    $diff = balanceCalcDiff();
    $h3_label->configure( -text => "Debits = $debits  " .
                            "Credits = $credits  Difference = $diff");
  });

  $h2_entry->bind('<FocusOut>', sub {
    $diff = balanceCalcDiff();
    $h3_label->configure( -text => "Debits = $debits  " .
                            "Credits = $credits  Difference = $diff");
  });
  
  $f_list->bind('<Double-Button>', sub {
    acctSetDirty();
    balanceUpdateList($f_list, $f_list->curselection());
    $diff=balanceCalcDiff();
    $h3_label->configure( -text => "Debits = $debits  " .
                            "Credits = $credits  Difference = $diff");
  });
  $h1_entry->focus();
}

$main_win = new MainWindow;
cbbWindow_bal();
MainLoop;


__END__
