#!/usr/bin/perl -w

# ToDo

# Make sure to change hard coded fonts etc back.

# db_close.
# Make sure we close all open windows in db_close.


use strict;
use IO;
use Tk::FileDialog;

my $current_db_name = undef;

sub db_get_name {
  return $current_db_name;
}

sub db_set_name {
  my($name) = @_;
  $current_db_name = $name;
  acct_win_reset_title($main::mw);
  return 1;
}

sub db_get_new_filename {
  # Now find a new one.  
  $main::mw->optionAdd('*font', $pref_default_font);

  my $win = $main::mw->FileDialog(-Title => 'Save Database As:',
                                  -Path => mypwd(),
                                  -FPat => '*.cbb');
  my $select_result = $win->Show(-Title => "FOOBAZ");
  
  return $select_result;
}

sub db_new {
  return 0 unless db_save("creating a new database");
  return 0 unless db_close();
  
  $main::db = new CBBlib::Db;
  set_acct_list_contents($main::db);
  
  return 1;
}


sub db_load {
  my($filename) = @_;

  db_set_name($filename);

  my $clean_name = $filename;
  $clean_name =~ s/$ENV{'HOME'}/~/o;
  status_message("Loading data from $clean_name");
  $main::mw->update();
  $main::db = CBBlib::load_file($filename);
  status_message("$clean_name");
  
  set_acct_list_contents($main::db);
}

sub db_save_as {
  my $current_action = shift;
  # Query for a new name and then db_save;
  my $new_name = db_get_new_filename();
  if(defined($new_name)) {
    db_set_name($new_name); 
    db_save($current_action);
  }
  return $new_name;
}
  

sub db_save {
  my $current_action = shift;

  if($main::db) {        
    if(!$main::db->clean_p()) {
      my $should_save = 1;
      if($current_action && !$pref_auto_save) {
        $should_save = 
            yesno_window("You have not saved your current changes.  " . 
                         "Would you like to save before $current_action?");
      }
      return 0 if !defined($should_save); # User cancel...
      
      if($should_save) {
        if(!db_get_name()) {
          my $new_name = db_get_new_filename();
          if(defined($new_name)) {
            db_set_name($new_name);
          } else {
            return 0;
          }
        }

        debug('Saving file to ' . db_get_name() . "\n");

        my $stamp = timestamp();
        my $filename = db_get_name();
        if(-e $filename) {
          $filename =~ /(.*)\.cbb$/o;
          system("cp $filename $1-${stamp}.cbb");
        }
        my $fh = new IO::File;
        if($fh->open(">$filename")) {
          $main::db->print($fh);
          $fh->close() or print STDERR "Error closing output file\n";
        } else {
          ok_window('Could not save current database.  ' . 
                    'Error opening output file.');
          return 0;
        }
      }
    }
  }
  return 1;
}

sub db_close {
  if($main::db) {
    
  }
  $main::db = undef;
  db_set_name(undef);
}

1
__END__
