#!/usr/bin/perl -w

use strict;
use Tk;

#------------------------------------------------------------------------------
# Yes/No message for general use
#------------------------------------------------------------------------------

my $yesno_win = '';

sub yesno_window {
  my($message) = @_;
  my $result;
  
  if($yesno_win && $yesno_win->Exists()) { $yesno_win->destroy(); }
  
  $main::mw->optionAdd('*font', $pref_msg_text_font);
  $yesno_win = $main::mw->Toplevel();
  
  $yesno_win->title('Yes / No');
  $yesno_win->iconname('Yes / No');

  my $frame = $yesno_win->Frame(-borderwidth => 2, -relief => 'groove');
  
  my $m = $frame->Message(-width => 300, -text => $message);

  my $b_frame = $frame->Frame(-borderwidth => 0);
  my $yes_b = 
    $b_frame->Button(-text => ' Yes ', -font => $pref_button_font,
                     -command => sub {
                       $result = 1;
                       $yesno_win->destroy();
                     });

  my $no_b = 
    $b_frame->Button(-text => ' No ', -font => $pref_button_font,
                     -command => sub {
                       $result = 0;
                       $yesno_win->destroy();
                     });
  
  my $cancel_b = 
    $b_frame->Button(-text => ' Cancel ', -font => $pref_button_font,
                     -command => sub {
                       $result = undef();
                       $yesno_win->destroy();
                     });
  
  $frame->pack(-side => 'top', -fill => 'both', 
               -expand => 1, -padx => 4, -pady => 4);
  $b_frame->pack(-side => 'bottom', -fill => 'x');
  $yes_b->pack(-side => 'left', -fill => 'x',
               -expand => 1, -padx => 8, -pady => 8);
  $no_b->pack(-side => 'left', -fill => 'x',
              -expand => 1, -padx => 8, -pady => 8);
  $cancel_b->pack(-side => 'left', -fill => 'x',
                  -expand => 1, -padx => 8, -pady => 8);
  
  $m->pack(-side => 'top', -fill => 'both', -expand => 1);
  $yesno_win->waitWindow();
  return $result;
}
1;
__END__
